#!/usr/bin/env bash

set -e
oldrev=$1
newrev=$2

run() {
  [ -x $1 ] && $1 $oldrev $newrev
}

echo files changed: $(git diff $oldrev $newrev --diff-filter=ACDMR --name-only | wc -l)

umask 002

git submodule sync && git submodule update --init --recursive

run bin/deploy/remote/before_restart
run bin/deploy/remote/restart && run bin/deploy/remote/after_restart
